<?php

namespace Management\Services;

use Management\Services\ObjetoVendaHora;

class ObjetoUnidade {

	private $cdfilial;
	private $nmfilial;
	private $vendas;

	public function __construct($cdfilial, $nmfilial) {
		$this->setCdFilial($cdfilial);
		$this->vendas = array();
	}
	

    public function setCdFilial ($cdfilial) {
        $this->cdfilial = $cdfilial;
    }
    
    public function getNmFilial() {
        return $this->nmfilial;
    }
    
    public function setNmFilial ($nmfilial) {
        $this->nmfilial = $nmfilial;
    }
    
    public function getCdFilial() {
        return $this->cdfilial;
    }
    
    public function getLabelFilial() {
        return $this->getCdFilial().$this->getNmFilial();
    }
   
    public function addVendas ($hora, $totalVendido, $meta) {
        $obj = new ObjetoVendaHora($hora, $totalVendido, $meta);
        $this->vendas[] = $obj;
    }
    
    public function getVendas($horaAtual) {
        
        $array = array();
        $computar = false;
        
        foreach($this->vendas as $venda) {
            $obj = array(
                "DATA"       => $venda->getHora(),
                "TOTALVEND"  => $venda->getTotalVendido(),
                "META"       => $venda->getMeta()
            );
            
            if($horaAtual == $obj["DATA"]) {
                $obj["HORAATUAL"] = $obj["TOTALVEND"];
            }
            
            if($obj["TOTALVEND"] > 0 || $computar) {
                $computar = true;
                $array[] = $obj;
            }
        }
        return $array;
    } 

}