create or replace
PROCEDURE USR_PRECO_FORN_IRREGULAR
  (P_DTINICIAL  IN DATE,
   P_DTFINAL    IN DATE) IS
 
   V_DTGRV      DATE;
   V_HRGRV      VARCHAR2(4);
   V_CDREGIAO   FILIAL.CDREGIAO%TYPE;
   V_CDMARCA    ITEMCOLE.CDMARCA%TYPE;
   V_NMMARCA    MARCA.NMMARCA%TYPE;
   V_CDFORNECED FORNECEDOR.CDFORNECED%TYPE;
 
   V_CDEXFORN   VARCHAR2(20);
   V_ERROR      VARCHAR2(4000);
   V_RETURN     VARCHAR2(1);
   V_CONSULTA   VARCHAR2(55);
   V_UOMSALALT  VARCHAR2(10);
   V_CDARVPROD  VARCHAR2(20);
   V_SEQUENCIAL INTEGER;
 
   /* - Declarao de cursores ---------------------------------------------- */
   CURSOR C_REGIAO IS
      SELECT DISTINCT CDREGIAO
        FROM FILGRUPFILI, FILIAL
       WHERE FILGRUPFILI.CDGRUPFILI = '9999999999'
         AND FILGRUPFILI.CDFILIAL   = FILIAL.CDFILIAL;
   
   CURSOR C_FORNECEDOR IS
      SELECT CDFORNECED
        FROM USR_FORN_IRREGULAR;
   BEGIN
      V_RETURN := USR_FUNC_BLOQUEIO('USR_LISTAPRECO_IR', 'B');
 
      IF V_RETURN = 'S' THEN
         V_DTGRV := NULL;
 
         V_HRGRV := NULL;
         
         /* Retorna data e hora de exportao */
         BEGIN
            SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
              INTO V_DTGRV, V_HRGRV
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTGRV := NULL;
               V_HRGRV := NULL;
         END;
 
         DELETE FROM USR_LISTAPRECO_IR;
 
         OPEN C_REGIAO;
         LOOP
            FETCH C_REGIAO INTO V_CDREGIAO;
            EXIT WHEN C_REGIAO%NOTFOUND;
 
            OPEN C_FORNECEDOR;
            LOOP
               FETCH C_FORNECEDOR INTO V_CDFORNECED;
               EXIT WHEN C_FORNECEDOR%NOTFOUND;
 
               FOR C_LISTA IN
                  (SELECT DISTINCT
                     LISTA_FILIAL.CDFILIAL CDFILIAL,
                     ITEMCOLE.CDFORNECED,
                     ITEMCOLE.CDPRODUTO,
                     ITEMCOLE.DTINIVALITM,
                     P.CDEXFILIAL,
                     ITEMCOLE.CDMARCA,
                     DECODE((SELECT NVL(IDTIPOAPUR, 0)
                               FROM PARASUPRI
                              WHERE PARASUPRI.CDFILIAL = ITEMCOLE.CDFILIAL), 0, ITEMCOLE.VRPRECUNIITM,
                     DECODE((SELECT NVL(IDTIPOAPUR, 0)
                               FROM PARASUPRI
                              WHERE PARASUPRI.CDFILIAL = ITEMCOLE.CDFILIAL), 1, ITEMCOLE.VRPRECECOITM, ITEMCOLE.VRPRECOITMPI)) VRPRECUNICMP,
                     ITEMCOLE.VRPRECUNIITM
                   FROM
                     ITEMCOLE,
                     FILIAL,
                     FILIAL LISTA_FILIAL,
                     PARAMFILIAL P
                   WHERE (ITEMCOLE.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL))
                     AND (ITEMCOLE.CDFILIAL = P.CDFILIAL)
                     AND (P.CDFILIAL = FILIAL.CDFILIAL)
                     AND (ITEMCOLE.IDITMLISPREC = 'S')
                     AND (ITEMCOLE.DTINIVALITM >= P_DTINICIAL)
                     AND (ITEMCOLE.DTFINVALITM <= P_DTFINAL)
                     AND (ITEMCOLE.CDFORNECED   = V_CDFORNECED)
                     AND (ITEMCOLE.VRPRECUNIITM > 0)
                     AND (ITEMCOLE.CDREGIAO     = V_CDREGIAO)
                     AND (LISTA_FILIAL.CDREGIAO = V_CDREGIAO)
                     AND EXISTS (SELECT 1
                                   FROM FILGRUPFILI
                                  WHERE FILGRUPFILI.CDGRUPFILI = '9999999999'
                                    AND FILGRUPFILI.CDFILIAL = LISTA_FILIAL.CDFILIAL)
                      /* Incio das Particularidades da Filial */
                     AND (NOT EXISTS (SELECT 1
                                        FROM REFORFIL
                                       WHERE (CDFILIAL   = LISTA_FILIAL.CDFILIAL)
                                         AND (CDFORNECED = V_CDFORNECED)
                                         AND (CDPERIENTR IS NULL)))
                     AND (NOT EXISTS (SELECT 1
                                        FROM REFOREG
                                       WHERE (REFOREG.CDREGIAO   = V_CDREGIAO)
                                         AND (REFOREG.CDFORNECED = V_CDFORNECED)))
                     AND ((EXISTS (SELECT 1
                                     FROM PARTFILI
                                    WHERE (CDFILIAL  = LISTA_FILIAL.CDFILIAL)
                                      AND (CDPRODUTO = ITEMCOLE.CDPRODUTO)
                                      AND (CDTIPPART IN ('1', '2'))
                                      AND (CDMARCA   = ITEMCOLE.CDMARCA)
                                      AND (NOT EXISTS (SELECT 1
                                                         FROM PARTFILI
                                                        WHERE (CDFILIAL    = LISTA_FILIAL.CDFILIAL)
                                                          AND (CDPRODUTO   = ITEMCOLE.CDPRODUTO)
                                                          AND (CDTIPPART   IN ('4', '5'))
                                                          AND (NRCOLEPRECO IS NULL)
                                                          AND (CDFORNECED  <> V_CDFORNECED)))))
                           OR (EXISTS (SELECT 1
                                         FROM PARTFILI
                                        WHERE (CDFILIAL    = LISTA_FILIAL.CDFILIAL)
                                          AND (CDPRODUTO   = ITEMCOLE.CDPRODUTO)
                                          AND (CDTIPPART   IN ('4', '5'))
                                          AND (NRCOLEPRECO IS NULL)
                                          AND (CDFORNECED  = V_CDFORNECED)
                                          AND (NOT EXISTS (SELECT 1
                                                             FROM PARTFILI
                                                            WHERE (CDFILIAL  = LISTA_FILIAL.CDFILIAL)
                                                              AND (CDPRODUTO = ITEMCOLE.CDPRODUTO)
                                                              AND (CDTIPPART IN ('1', '2'))
                                                              AND (CDMARCA   <> ITEMCOLE.CDMARCA))
                                               )
                                       )
                               )
                           OR (EXISTS (SELECT 1
                                         FROM PARTFILI
                                        WHERE (CDFILIAL   = LISTA_FILIAL.CDFILIAL)
                                          AND (CDPRODUTO  = ITEMCOLE.CDPRODUTO)
                                          AND (CDTIPPART  IN ('7', '8'))
                                          AND (CDMARCA    = ITEMCOLE.CDMARCA)
                                          AND (CDFORNECED = V_CDFORNECED))
                               )
                           OR (EXISTS (SELECT 1
                                         FROM PARTFILI
                                        WHERE (CDFILIAL  = LISTA_FILIAL.CDFILIAL)
                                          AND (CDPRODUTO = ITEMCOLE.CDPRODUTO)
                                          AND (CDTIPPART  IN ('3','6','9')))
                                          AND NOT EXISTS (SELECT 1
                                                            FROM PARTFILI
                                                           WHERE (CDFILIAL  = LISTA_FILIAL.CDFILIAL)
                                                             AND (CDPRODUTO = ITEMCOLE.CDPRODUTO)
                                                             AND (NRCOLEPRECO IS NULL)
                                                            AND (CDTIPPART  IN ('1','2','4','5','7','8')))
                               )
                           OR (NOT EXISTS (SELECT 1
                                             FROM PARTFILI
                                            WHERE (CDFILIAL  = LISTA_FILIAL.CDFILIAL)
                                              AND (NRCOLEPRECO IS NULL)
                                              AND (CDPRODUTO = ITEMCOLE.CDPRODUTO))
                               )
                         )
                     AND (NOT EXISTS (SELECT 1
                                        FROM PARTFILI
                                       WHERE (CDFILIAL  = LISTA_FILIAL.CDFILIAL)
                                         AND (CDPRODUTO = ITEMCOLE.CDPRODUTO)
                                         AND (CDTIPPART = '3')
                                         AND (CDMARCA   = ITEMCOLE.CDMARCA)))
                     AND (NOT EXISTS (SELECT 1
                                        FROM PARTFILI
                                       WHERE (CDFILIAL   = LISTA_FILIAL.CDFILIAL)
                                         AND (CDPRODUTO  = ITEMCOLE.CDPRODUTO)
                                         AND (CDTIPPART  = '6')
                                         AND (CDFORNECED = V_CDFORNECED)))
                     AND (NOT EXISTS (SELECT 1
                                        FROM PARTFILI
                                       WHERE (CDFILIAL   = LISTA_FILIAL.CDFILIAL)
                                         AND (CDPRODUTO  = ITEMCOLE.CDPRODUTO)
                                         AND (CDTIPPART  = '9')
                                         AND (CDMARCA    = ITEMCOLE.CDMARCA)
                                         AND (CDFORNECED = V_CDFORNECED))))
               /* Fim das Particularidades da Filial */
               LOOP
                  BEGIN
                     SELECT NMMARCA
                       INTO V_NMMARCA
                       FROM MARCA
                      WHERE CDMARCA = C_LISTA.CDMARCA;
                  EXCEPTION
                    WHEN OTHERS THEN
                       V_NMMARCA := NULL;
                  END;
    
                  BEGIN
                     SELECT CDEXFORNECED
                       INTO V_CDEXFORN
                       FROM FORNECEDOR
                      WHERE CDFORNECED = C_LISTA.CDFORNECED;
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_CDEXFORN := NULL;
                  END;
    
                  BEGIN
                     SELECT MIN(UOMSAPALT), MIN(CDARVPROD)
                       INTO V_UOMSALALT, V_CDARVPROD
                       FROM MARCPROD M, PRODUTO P
                      WHERE M.CDPRODUTO = P.CDPRODUTO
                        AND P.CDPRODUTO = C_LISTA.CDPRODUTO
                        AND M.CDMARCA   = C_LISTA.CDMARCA;
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_UOMSALALT := NULL;
                        V_CDARVPROD := NULL;
                  END;
    
                  INSERT INTO USR_LISTAPRECO_IR (CDFILIAL, CDPRODUTO, CDFORNECED, DTREFERENCIA,
                                                 VRPRECUNICMP, CDMARCA, NMMARCA, IDORIGREGISTRO,
                                                 DTGRAVACAO, HRGRAVACAO, DTIMPORTACAO, HRIMPORTACAO,
                                                 CDSITESAP, CDPROVEESAP, VRPRECUNIITM,
                                                 CDARVPROD, UOMSAPALT)
                       VALUES(C_LISTA.CDFILIAL, C_LISTA.CDPRODUTO, C_LISTA.CDFORNECED, C_LISTA.DTINIVALITM,
                              C_LISTA.VRPRECUNICMP, C_LISTA.CDMARCA, V_NMMARCA, 'T',
                              V_DTGRV, V_HRGRV, NULL, NULL,
                              C_LISTA.CDEXFILIAL, V_CDEXFORN, C_LISTA.VRPRECUNIITM,
                              V_CDARVPROD, V_UOMSALALT);
               END LOOP;
            END LOOP;
            CLOSE C_FORNECEDOR;
            
            COMMIT;
         END LOOP;
         CLOSE C_REGIAO;
         
         V_RETURN := USR_FUNC_BLOQUEIO('USR_LISTAPRECO_IR', 'D');
      END IF;
   EXCEPTION
      WHEN OTHERS THEN BEGIN
         ROLLBACK;
     
         IF V_RETURN = 'S' THEN
            V_ERROR  := SQLERRM(SQLCODE);
            V_RETURN := USR_FUNC_BLOQUEIO('USR_LISTAPRECO_IR', 'D', V_ERROR);
         END IF;
    
         IF TRIM(V_ERROR) IS NULL THEN
            V_ERROR := SQLERRM(SQLCODE);
         END IF;
         
         SELECT USR_SAP_IDINTERFACE.NEXTVAL
           INTO V_SEQUENCIAL
           FROM DUAL;         
         
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES(V_SEQUENCIAL, 'I', 10, SYSDATE, 1, 'Error: '|| V_ERROR);
   END;  
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_PRECO_FORN_IRREGULAR','6.05.xxx'); END;
/